%global namedreltag -milestone-3
%global namedversion %{version}%{?namedreltag}
%define bootstrap 0

# TODO grails-core.jar http://repo1.maven.org/maven2/org/grails/grails-core/1.3.7/grails-core-1.3.7.jar
#https://github.com/grails/grails-core/
Name:          gradle
Version:       1.0
Release:       %mkrel 8
Summary:       Groovy based build system
Group:         Development/Java
License:       ASL 2.0
Url:           http://www.gradle.org/
Source0:       http://repo.gradle.org/gradle/distributions/gradle-%{namedversion}-src.zip
#%if %bootstrap
Source1:       http://repo.gradle.org/gradle/distributions/gradle-%{namedversion}-bin.zip
#%endif

Source3:       gradle-wrapper

Patch0:        gradle-1.0-setup.patch
Patch1:        gradle-1.0-guava.patch
Patch2:        gradle-1.0-jna.patch
Patch3:        gradle-1.0-wrapper_properties.patch
# webdavlib-2.0.jar
Patch4:        gradle-1.0-webdavlib.patch
# sonar-batch-bootstrapper-2.6.jar
Patch5:        gradle-1.0-sonarplugin.patch
# pmaven-common-0.8-20100325.jar  
# pmaven-groovy-0.8-20100325.jar 
Patch6:        gradle-1.0-pmaven.patch

# TODO
# jetty-6.1.25.jar  
# jetty-util-6.1.25.jar  
# jetty-plus-6.1.25.jar  
# jetty-naming-6.1.25.jar  
# jetty-annotations-6.1.25.jar 
# jsp-api-2.1-6.1.14.jar  
# jsp-2.1-6.1.14.jar
# servlet-api-2.5-20081211.jar 
Patch7:        gradle-1.0-jetty.patch
Patch8:        gradle-1.0-checkstyle.patch
Patch9:        gradle-1.0-0-fixdoc.patch
Patch10:       gradle-1.0-fixdeps.patch
Patch11:       gradle-1.0-PlexusLoggerAdapter.patch
Patch12:       gradle-1.0-Version.patch
Patch13:       gradle-1.0-set_classpath.patch



BuildRequires: java-devel
BuildRequires: jpackage-utils

BuildRequires: jopt-simple
# core
BuildRequires: ant
BuildRequires: apache-commons-cli
BuildRequires: apache-commons-codec
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-io
BuildRequires: apache-commons-lang
BuildRequires: dom4j
BuildRequires: google-collections
%if !%bootstrap
BuildRequires: gradle
%endif
# groovy-all.jar
BuildRequires: groovy == 1.7.10
BuildRequires: guava
BuildRequires: ivy
BuildRequires: jakarta-commons-httpclient
BuildRequires: jansi
BuildRequires: jaxen
BuildRequires: jna
BuildRequires: jna-posix
BuildRequires: jsch
BuildRequires: jzlib
BuildRequires: logback
BuildRequires: objectweb-asm
BuildRequires: slf4j

# core-impl
BuildRequires: maven2
BuildRequires: maven-ant-tasks
BuildRequires: maven-wagon
BuildRequires: plexus-component-api
BuildRequires: plexus-containers-component-annotations 
BuildRequires: plexus-utils

# plugins
BuildRequires: ant-antlr
BuildRequires: antlr
BuildRequires: apache-commons-beanutils
BuildRequires: aqute-bndlib
BuildRequires: beust-jcommander
BuildRequires: cglib
BuildRequires: bsh2
BuildRequires: checkstyle
BuildRequires: codenarc
BuildRequires: gmetrics
BuildRequires: jmock2
BuildRequires: objenesis
BuildRequires: snakeyaml
BuildRequires: junit4

#BuildRequires: jetty
#BuildRequires: ecj eclipse-jdt jar
#BuildRequires: geronimo-annotation-1.0-api

BuildRequires: hamcrest
BuildRequires: nekohtml
BuildRequires: testng
BuildRequires: xmlunit


Requires:      ant
Requires:      ant-antlr
Requires:      antlr
Requires:      apache-commons-beanutils
Requires:      apache-commons-cli
Requires:      apache-commons-codec
Requires:      apache-commons-collections
Requires:      apache-commons-io
Requires:      apache-commons-lang
Requires:      aqute-bndlib
Requires:      bsh                         
Requires:      checkstyle                  
Requires:      codenarc
Requires:      dom4j
Requires:      gmetrics
Requires:      google-collections
Requires:      groovy == 1.7.10
Requires:      ivy
Requires:      jansi
Requires:      jaxen
Requires:      jna
Requires:      jna-posix
Requires:      jopt-simple
Requires:      jsch
Requires:      junit4
Requires:      jzlib
Requires:      logback
Requires:      maven2
Requires:      maven-ant-tasks
Requires:      maven-wagon
Requires:      objectweb-asm
Requires:      plexus-containers-component-annotations
Requires:      plexus-component-api
Requires:      plexus-utils
Requires:      slf4j
Requires:      testng

Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils

Obsoletes:     gradle32
Provides:      gradle32

%description
Gradle is a build system written in Groovy. It uses Groovy
also as the language for its build scripts. It has a powerful
multi-project build support. It has a layer on top of Ivy
that provides a build-by-convention integration for Ivy. It
gives you always the choice between the flexibility of Ant
and the convenience of a build-by-convention behavior.

%package -n gradle-javadoc
Group:         Development/Java
Summary:       Javadoc for %{name}
Requires:      %{name} = %{?epoch:%epoch:}%{version}-%{release}
Requires:      jpackage-utils
BuildArch:     noarch

%description -n gradle-javadoc
Gradle - Groovy based build system.

This package contains javadoc for %{name}.

%prep
%setup -q -n gradle-%{namedversion}

%patch0 -p1
%patch1 -p0
%patch2 -p1
%ifarch x86_64
sed -i 's|/usr/lib|%{_libdir}|' subprojects/core/src/main/groovy/org/gradle/logging/LoggingServiceRegistry.java
%endif
%patch3 -p0
#%if %bootstrap
sed -i 's|@@ARCHIVE@@|file://%{SOURCE1}|' gradle/wrapper/gradle-wrapper.properties
#%endif
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p0
%patch9 -p1
%patch10 -p1
%patch11 -p0
%patch12 -p0
%patch13 -p0


%build

export GRADLE_USER_HOME=$PWD
%if %bootstrap
./gradlew --stacktrace --debug assemble
%else
mkdir -p gradlehome
gradle assemble --stacktrace --debug -g $PWD/gradlehome -b $PWD/build.gradle
%endif

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_datadir}/gradle/{bin,lib/core-impl,lib/plugins}
mkdir -p %{buildroot}%{_javadocdir}/gradle 
mkdir -p gradlehome
(
  cd gradlehome
  rm -rf *
  unzip ../build/distributions/gradle-%{namedversion}-all.zip
  (
    cd gradle-%{namedversion}
    install -pm 755 bin/gradle %{buildroot}%{_datadir}/gradle/bin/

    sed -i "s|# Attempt to set GRADLE_HOME|export JAVA_HOME=/usr/lib/jvm/java|" %{buildroot}%{_datadir}/gradle/bin/gradle
    sed -i 's|GRADLE_HOME="`pwd -P`"|export GRADLE_HOME=%{_datadir}/gradle|'  %{buildroot}%{_datadir}/gradle/bin/gradle
#    sed -i 's|CLASSPATH=|CLASSPATH=$CLASSPATH:|'  %{buildroot}%{_datadir}/gradle/bin/gradle
    install -pm 644 lib/gradle-core-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/
    install -pm 644 lib/gradle-launcher-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/
    install -pm 644 lib/gradle-open-api-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/
    install -pm 644 lib/gradle-tooling-api-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/
    install -pm 644 lib/gradle-ui-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/
    install -pm 644 lib/gradle-wrapper-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/

    install -pm 644 lib/core-impl/gradle-core-impl-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/core-impl

    install -pm 644 lib/plugins/gradle-announce-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/plugins
    install -pm 644 lib/plugins/gradle-antlr-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/plugins
    install -pm 644 lib/plugins/gradle-code-quality-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/plugins
    install -pm 644 lib/plugins/gradle-ide-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/plugins
# TODO    install -pm 644 lib/plugins/gradle-jetty-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/plugins
    install -pm 644 lib/plugins/gradle-maven-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/plugins
    install -pm 644 lib/plugins/gradle-osgi-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/plugins
    install -pm 644 lib/plugins/gradle-plugins-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/plugins
    install -pm 644 lib/plugins/gradle-scala-%{namedversion}.jar %{buildroot}%{_datadir}/gradle/lib/plugins

    cp -pr docs/groovydoc %{buildroot}%{_javadocdir}/gradle
    cp -pr docs/javadoc/* %{buildroot}%{_javadocdir}/gradle

    mv LICENSE ../../
    mv NOTICE ../../
    mv changelog.txt ../../
  )
)

mkdir -p %{buildroot}%{_javadir}/

(
  cd %{buildroot}%{_datadir}/gradle/lib/
# intellij build requires
  ln -sf ../gradle/lib/gradle-open-api-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-open-api.jar

  ln -sf ../gradle/lib/gradle-core-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-core.jar
#  ln -sf ../gradle/lib/gradle-launcher-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-launcher.jar
#  ln -sf ../gradle/lib/gradle-tooling-api-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-tooling-api.jar
#  ln -sf ../gradle/lib/gradle-ui-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-ui.jar
  ln -sf ../gradle/lib/gradle-wrapper-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-wrapper.jar
)

(
  cd %{buildroot}%{_datadir}/gradle/lib/plugins
  ln -sf ../gradle/lib/plugins/gradle-announce-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-announce.jar
  ln -sf ../gradle/lib/plugins/gradle-antlr-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-antlr.jar
  ln -sf ../gradle/lib/plugins/gradle-code-quality-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-code-quality.jar
  ln -sf ../gradle/lib/plugins/gradle-ide-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-ide.jar
# TODO    ln -sf ../gradle/lib/plugins/gradle-jetty-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-jetty.jar
  ln -sf ../gradle/lib/plugins/gradle-maven-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-maven.jar
  ln -sf ../gradle/lib/plugins/gradle-osgi-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-osgi.jar
  ln -sf ../gradle/lib/plugins/gradle-plugins-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-plugins.jar
  ln -sf ../gradle/lib/plugins/gradle-scala-%{namedversion}.jar %{buildroot}%{_javadir}/gradle-scala.jar
)

ln -sf %{_javadir}/ant.jar %{buildroot}%{_datadir}/gradle/lib/ant.jar
ln -sf $(build-classpath ant-launcher)  %{buildroot}%{_datadir}/gradle/lib/ant-launcher.jar
ln -sf $(build-classpath objectweb-asm/asm-all) %{buildroot}%{_datadir}/gradle/lib/asm-all.jar
ln -sf $(build-classpath commons-cli) %{buildroot}%{_datadir}/gradle/lib/commons-cli.jar
ln -sf $(build-classpath commons-codec) %{buildroot}%{_datadir}/gradle/lib/commons-codec.jar
ln -sf $(build-classpath commons-collections) %{buildroot}%{_datadir}/gradle/lib/commons-collections.jar
ln -sf $(build-classpath commons-httpclient) %{buildroot}%{_datadir}/gradle/lib/commons-httpclient.jar
ln -sf $(build-classpath commons-io) %{buildroot}%{_datadir}/gradle/lib/commons-io.jar
ln -sf $(build-classpath commons-lang) %{buildroot}%{_datadir}/gradle/lib/commons-lang.jar
ln -sf $(build-classpath dom4j) %{buildroot}%{_datadir}/gradle/lib/dom4j.jar
ln -sf $(build-classpath google-collections) %{buildroot}%{_datadir}/gradle/lib/google-collections.jar
ln -sf $(build-classpath groovy17-all) %{buildroot}%{_datadir}/gradle/lib/groovy-all.jar
ln -sf $(build-classpath ivy) %{buildroot}%{_datadir}/gradle/lib/ivy.jar
ln -sf $(build-classpath jansi) %{buildroot}%{_datadir}/gradle/lib/jansi.jar
ln -sf $(build-classpath jaxen) %{buildroot}%{_datadir}/gradle/lib/jaxen.jar
ln -sf $(build-classpath jna) %{buildroot}%{_datadir}/gradle/lib/jna.jar
ln -sf $(build-classpath jna-posix) %{buildroot}%{_datadir}/gradle/lib/jna-posix.jar
ln -sf $(build-classpath jopt-simple) %{buildroot}%{_datadir}/gradle/lib/jopt-simple.jar
ln -sf $(build-classpath jsch) %{buildroot}%{_datadir}/gradle/lib/jsch.jar
ln -sf $(build-classpath junit4) %{buildroot}%{_datadir}/gradle/lib/junit4.jar
ln -sf $(build-classpath jzlib) %{buildroot}%{_datadir}/gradle/lib/jzlib.jar
ln -sf $(build-classpath slf4j/api) %{buildroot}%{_datadir}/gradle/lib/slf4j-api.jar
ln -sf $(build-classpath slf4j/jcl-over-slf4j) %{buildroot}%{_datadir}/gradle/lib/jcl-over-slf4j.jar
ln -sf $(build-classpath slf4j/jul-to-slf4j) %{buildroot}%{_datadir}/gradle/lib/jul-to-slf4j.jar
ln -sf $(build-classpath slf4j/log4j-over-slf4j) %{buildroot}%{_datadir}/gradle/lib/log4j-over-slf4j.jar
ln -sf $(build-classpath slf4j/log4j12) %{buildroot}%{_datadir}/gradle/lib/slf4j-log4j12.jar
ln -sf $(build-classpath logback/classic) %{buildroot}%{_datadir}/gradle/lib/logback-classic.jar
ln -sf $(build-classpath logback/core) %{buildroot}%{_datadir}/gradle/lib/logback-core.jar

ln -sf $(build-classpath maven-ant-tasks) %{buildroot}%{_datadir}/gradle/lib/core-impl/maven-ant-tasks.jar
ln -sf $(build-classpath maven2/maven-artifact) %{buildroot}%{_datadir}/gradle/lib/core-impl/maven-artifact.jar
ln -sf $(build-classpath maven2/maven-artifact-manager) %{buildroot}%{_datadir}/gradle/lib/core-impl/maven-artifact-manager.jar
ln -sf $(build-classpath maven2/maven-model) %{buildroot}%{_datadir}/gradle/lib/core-impl/maven-model.jar
ln -sf $(build-classpath maven2/maven-project) %{buildroot}%{_datadir}/gradle/lib/core-impl/maven-project.jar
ln -sf $(build-classpath maven2/maven-settings) %{buildroot}%{_datadir}/gradle/lib/core-impl/maven-settings.jar
ln -sf $(build-classpath maven2/maven-settings) %{buildroot}%{_datadir}/gradle/lib/core-impl/maven-settings.jar
ln -sf $(build-classpath plexus/containers-component-annotations) %{buildroot}%{_datadir}/gradle/lib/core-impl/plexus-component-annotations.jar
ln -sf $(build-classpath plexus/plexus-component-api) %{buildroot}%{_datadir}/gradle/lib/core-impl/plexus-component-api.jar
ln -sf $(build-classpath plexus/utils) %{buildroot}%{_datadir}/gradle/lib/core-impl/plexus-utils.jar
ln -sf $(build-classpath maven-wagon/provider-api) %{buildroot}%{_datadir}/gradle/lib/core-impl/wagon-provider-api.jar

ln -sf $(build-classpath ant/ant-antlr) %{buildroot}%{_datadir}/gradle/lib/plugins/ant-antlr.jar
ln -sf $(build-classpath antlr) %{buildroot}%{_datadir}/gradle/lib/plugins/antlr.jar
ln -sf $(build-classpath aqute-bndlib) %{buildroot}%{_datadir}/gradle/lib/plugins/bnd.jar
ln -sf $(build-classpath bsh2/bsh) %{buildroot}%{_datadir}/gradle/lib/plugins/bsh.jar
ln -sf $(build-classpath checkstyle) %{buildroot}%{_datadir}/gradle/lib/plugins/checkstyle.jar
ln -sf $(build-classpath commons-beanutils) %{buildroot}%{_datadir}/gradle/lib/plugins/commons-beanutils.jar
ln -sf $(build-classpath CodeNarc) %{buildroot}%{_datadir}/gradle/lib/plugins/CodeNarc.jar
ln -sf $(build-classpath GMetrics) %{buildroot}%{_datadir}/gradle/lib/plugins/GMetrics.jar
ln -sf $(build-classpath junit4) %{buildroot}%{_datadir}/gradle/lib/plugins/junit4.jar
ln -sf $(build-classpath testng) %{buildroot}%{_datadir}/gradle/lib/plugins/testng.jar

# eclipse-jdt jar
#ln -sf %{_javadir}/jetty.jar %{buildroot}%{_datadir}/gradle/lib/plugins/jetty.jar
#ln -sf %{_javadir}/jetty-annotations.jar %{buildroot}%{_datadir}/gradle/lib/plugins/jetty-annotations.jar
#ln -sf %{_javadir}/jetty-naming.jar %{buildroot}%{_datadir}/gradle/lib/plugins/jetty-naming.jar
#ln -sf %{_javadir}/jetty-plus.jar  %{buildroot}%{_datadir}/gradle/lib/plugins/jetty-plus.jar
#ln -sf %{_javadir}/jetty-util.jar %{buildroot}%{_datadir}/gradle/lib/plugins/jetty-util.jar
#ln -sf %{_javadir}/jsp-api-2.1.jar  %{buildroot}%{_datadir}/gradle/lib/plugins/jsp-api-2.1.jar
#ln -sf %{_javadir}/servlet-api-2.5.jar  %{buildroot}%{_datadir}/gradle/lib/plugins/servlet-api-2.5.jar
#ln -sf %{_javadir}/annotations-api.jar  %{buildroot}%{_datadir}/gradle/lib/plugins/annotations-api.jar

mkdir -p %{buildroot}%{_bindir}
install -pm 755 %{SOURCE3} %{buildroot}%{_bindir}/gradle

%files
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/gradle
%dir %{_datadir}/gradle
%attr(0755,root,root) %{_datadir}/gradle/bin/gradle
%{_datadir}/gradle/lib
%{_javadir}/*
%doc LICENSE NOTICE changelog.txt

%files -n gradle-javadoc
%{_javadocdir}/gradle


%changelog

* Thu Dec 08 2011 dmorgan <dmorgan> 1.0-8.mga2
+ Revision: 178772
- disable bootstrap
- disable bootstrap

* Thu Dec 01 2011 dmorgan <dmorgan> 1.0-7.mga2
+ Revision: 175003
- We need the same name for all arches
- Rebuild without bootstrap to see if x86_64 build is fixed

  + gil <gil>
    - added Obsoletes/Provides for gradle32
    - added Obsoletes/Provides for gradle32
    - try to fix multiarch support

* Thu Dec 01 2011 dmorgan <dmorgan> 1.0-4.mga2
+ Revision: 174810
- Enable bootstrap again

  + gil <gil>
    - build fix
      tryed to add multiarch support

* Mon Nov 28 2011 gil <gil> 1.0-3.mga2
+ Revision: 173866
- build fixed
  removed gradle-1.0-groovy17.patch (gradle requires groovy == 1.7.10)
  removed classpath export (gradle requires groovy-all-1.7.10.jar with internal asm)
- edit spec file, rebuilt with groovy17 support (dont work with groovy 1.8.x), bootstrap mode
- imported package gradle

  + dmorgan <dmorgan>
    - Fix group

